;Busca un element a llistes tipus ((1) (2)..)
(defun existeix (l1 elem)
    (if (null l1) nil
        (if (equal (car l1) elem) T
          (existeix (cdr l1) elem)
        )
    )
)

;Busca un element a llistes tipus (((1)...) ((2)...)..)
(defun existeix2 (l1 elem)
    (if (null l1) nil
        (if (equal (car (car l1)) elem) T
          (existeix2 (cdr l1) elem)
        )
    )
)

; Funci que retorna les operacions que s'han de realitzar per passar d'un
; estat (A B) a un (A' B'), si no hi ha cami retorna nil. Cerca en profunditat.
(defun gerres (pendents final tractats)
  (if (null pendents) nil ; No s'ha trobat soluci
    (if (equal (car (car pendents)) final)
      (if (null (reverse (cdr (car pendents))))
        '(0) ; Trobat! Estat inicial = Estat final, no ha fet cap operaci
        (reverse (cdr (car pendents))) ; Trobat! Retorna cami (est al revs)
      )
      ; Creem tots els possibles estats des de l'actual, afegint l'operaci que
      ; realitzem:
      ;  1.- Omplir A
      ;  2.- Omplir B
      ;  3.- Buidar A
      ;  4.- Buidar B
      ;  5.- Passar aigua d'A a B
      ;  6.- Passar aigua d'A a B
      (let (
            (omplirA 
              (cons
                  (cons
                    ; A = A + (4 - A)
                    (+ (car (car (car pendents))) (- 4 (car (car (car pendents)))))
                    (cdr (car (car pendents)))
                  )
                  ; Operaci
                  (cons 1 (cdr (car pendents)) )
              )   
            )
            (omplirB 
              (cons
                (cons 
                  (car (car (car pendents)))
                  ; B = B + (3 - B)
                  (list (+ (car (reverse (car (car pendents)))) (- 3 (car (reverse (car (car pendents)))))))
                )
                (cons 2 (cdr (car pendents)) )
              )
            )
            (buidarA 
              (cons
                (cons 
                  0
                  (cdr (car (car pendents)))
                )
                (cons 3 (cdr (car pendents)) )
              )   
            )
            (buidarB 
              (cons
                (cons 
                  (car (car (car pendents)))
                  '(0)
                )
                (cons 4 (cdr (car pendents)) )
              )
            )
            (ApassaB
              ;Si (A+B>3) llavors
              (if (> (+ (car (car (car pendents))) (car (cdr (car (car pendents))))) 3)
                (cons   ;(A+B > 3)
                  (cons
                    ;(A = A - (3 - B))
                    (- (car (car (car pendents))) (- 3 (car (reverse (car (car pendents))))))
                    '(3)
                  )
                  (cons 5 (cdr (car pendents)) )
                )
                (cons   ;(A+B < 3)
                  (cons
                    0
                    ;(B = B + A)
                    (list (+ (car (reverse (car (car pendents)))) (car (car (car pendents)))))
                  )
                  (cons 5 (cdr (car pendents)) )
                )
              )
            )
            (BpassaA
              ;Si (A+B>3) llavors
              (if (> (+ (car (car (car pendents))) (car (cdr (car (car pendents))))) 4)
                (cons   ;(A+B > 4)
                  (cons
                    4
                    ; (B = B - (4 - A))
                    (list (- (car (reverse (car (car pendents)))) (- 4 (car (car (car pendents))))))
                  )
                  (cons 6 (cdr (car pendents)) )
                )
                (cons   ;(A+B < 4)
                  (cons
                    ; (A = A + B)
                    (+  (car (car (car pendents))) (car (reverse (car (car pendents)))))
                    '(0)
                  )
                  (cons 6 (cdr (car pendents)) )
                )
              )
            )
            (nous '())
          )
          ; Afegim a "nous" els estats que no haguin sigut ja tractats o
          ; que no estiguin pendents de tractament.
          (if (not (existeix tractats (car omplirA)))
            (if (not (existeix2 pendents (car omplirA)))
              ; Es un nou estat, afegim
              (setq nous (cons omplirA nous))
              nil
            )
            nil
          )
          (if (not (existeix tractats (car omplirB)))
            (if (not (existeix2 pendents (car omplirB)))
              ; Es un nou estat, afegim
              (setq nous (cons omplirB nous))
              nil
            )
            nil
          )
          (if (not (existeix tractats (car buidarA)))
            (if (not (existeix2 pendents (car buidarA)))
              ; Es un nou estat, afegim
              (setq nous (cons buidarA nous))
              nil
            )
            nil
          )
          (if (not (existeix tractats (car buidarB)))
            (if (not (existeix2 pendents (car buidarB)))
              ; Es un nou estat, afegim
              (setq nous (cons buidarB nous))
              nil
            )
            nil
          )
          (if (not (existeix tractats (car ApassaB)))
            (if (not (existeix2 pendents (car ApassaB)))
              ; Es un nou estat, afegim
              (setq nous (cons ApassaB nous))
              nil
            )
            nil
          )
          (if (not (existeix tractats (car BpassaA)))
            (if (not (existeix2 pendents (car BpassaA)))
              ; Es un nou estat, afegim
              (setq nous (cons BpassaA nous))
              nil
            )
            nil
          )
          (gerres
                ; Afegim al principi ja que ha de funcionar com una pila
                (append nous (cdr pendents))
                final
                (cons (car (car pendents)) tractats)  ; LTractats = LTractats + Node;
                ; A pendents no cal guardar cam, noms estat
          )
      )
    
    )
  )
)

; Front-End per utilitzar la funci gerres de forma senzilla, simplement
; cal indicar estat inicial (e.g. '(4 3)) i estat final (e.g. '(0 1))
(defun cami (inicial final)
  (gerres (list (list inicial)) final '())
)
